﻿using System;
using System.Drawing;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Space_Invaders
{
    class Invader : Drawable
    {
        public enum invaderclass { class1, class2, class3, class4 } ;
        public invaderclass thisClass;
        bool bDestroyed;
        public Vector v;
        private int midpoint;
        public Invader(invaderclass invclass)
            : base()
        {
            thisClass = invclass;
            v = new Vector(0.0,0.0);
            bDestroyed = false ;
        }
        public Invader(Vector v, invaderclass invclass)
            : base()
        {
            this.thisClass = invclass;
            this.v = v;
            bDestroyed = false;
        }
        public bool Destroyed ( )
        {
            return bDestroyed ;
        }
        public override void Update()
        {
            this.Position.X += (float)v.x;
            this.Position.Y += (float)v.y;
        }
        public void Draw(Form1 parent, System.Drawing.Graphics g)
        {
            switch (thisClass)
            {
                case invaderclass.class1:
                    g.DrawImageUnscaled(parent.imageList1.Images[0], (int)this.Position.X - this.Width / 2, (int)this.Position.Y, this.Width, this.Height);
                    //g.DrawRectangle(Pens.White, this.Position.X - this.Width / 2, this.Position.Y, this.Width, this.Height);
                    break;
                case invaderclass.class2:
                    g.DrawImageUnscaled(parent.imageList1.Images[1], (int)this.Position.X - this.Width / 2, (int)this.Position.Y, this.Width, this.Height);
                    //g.DrawRectangle(Pens.Yellow, this.Position.X - this.Width / 2, this.Position.Y, this.Width, this.Height);
                    break;
                case invaderclass.class3:
                    //g.DrawRectangle(Pens.Green, this.Position.X - this.Width / 2, this.Position.Y, this.Width, this.Height);
                    g.DrawImageUnscaled(parent.imageList1.Images[2], (int)this.Position.X - this.Width / 2, (int)this.Position.Y, this.Width, this.Height);
                    break;
                case invaderclass.class4:
                    //g.DrawRectangle(Pens.Red, this.Position.X - this.Width / 2, this.Position.Y, this.Width, this.Height);
                    g.DrawImageUnscaled(parent.imageList1.Images[3], (int)this.Position.X - this.Width / 2, (int)this.Position.Y, this.Width, this.Height);
                    break;
            }
        }
        public bool Collision(Form1 parent, int width, int height)
        {
            if (!this.Destroyed()){
                if (this.Position.X + (this.Width / 2) > width - Form1.GAME_OFFSET_X)
                {
                    return true ;
                }else if ( this.Position.X - ( this.Width / 2 ) < Form1.GAME_OFFSET_X){
                    return true ;
                }
                else if (this.Position.Y - this.Height > height - Form1.GAME_OFFSET_Y)
                {
                    parent.GameOver();
                    return true;
                }
                return false;
            }else{
                return false ;
            }
        }
        public void Hit()
        {
            bDestroyed = true;
        }
    }
}
