﻿using System;
using System.Drawing;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Space_Invaders
{
    class PlayerMissle : Drawable
    {
        public Vector v = null;
        public PlayerMissle()
        {
            v = new Vector(0.0, -5.0);
        }
        public override void Update()
        {
            this.Position.X += (float)v.x;
            this.Position.Y += (float)v.y;
        }
        public override void Draw(System.Drawing.Graphics g)
        {
            g.DrawRectangle(Pens.White, this.Position.X - this.Width / 2, this.Position.Y - this.Height / 2, this.Width, this.Height);
        }
        public Invader Collision(Form1 frm, List<Invader> invaders){
            if (this.Position.Y < Form1.GAME_OFFSET_Y){
                return null;
            }
            Rectangle r = new Rectangle((int)this.Position.X, (int)this.Position.Y, this.Width, this.Height);
            foreach (Invader tmp in invaders){
                if (!tmp.Destroyed())
                {
                    Rectangle t = new Rectangle((int)tmp.Position.X - Form1.ENEMY_WIDTH / 2, (int)tmp.Position.Y, tmp.Width, tmp.Height);
                    if (r.IntersectsWith(t))
                    {
                        tmp.Hit();
                        return tmp;
                    }
                }
            }
            return null ;
        }
    }
}
